<template>
  <div
    id="app"
    :tabindex="1"
  >
    <div v-if="initialized">
      <router-view :key="$route.fullPath" />
      <component
        v-if="showDevButton"
        :is="'DevButton'"
        key="DevButton"
      />
      <TermsAndConditionsModal v-if="isTermsAndConditionsReady" />
    </div>

    <div
      v-else
    >
      <FastLoadingScreen class="window-height" />
    </div>
  </div>
</template>

<script>
import { defineAsyncComponent } from 'vue'
import { App } from '@capacitor/app'
import { SplashScreen } from '@capacitor/splash-screen'

import { listenDeepLinks } from 'src/services/deep-links'
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { LanguageMixin } from 'src/mixins/LanguageMixin'
import { initMobileServices } from 'src/services/mobile'
import { initializeUploadService, uploadServiceInstance } from 'src/services/photo/upload'
import { initErrorHandler, onInvalidConfigError } from 'src/services/error-handler'
import { initSentry } from 'src/services/sentry'
import { loadPortalConfiguration } from 'src/services/portal-configuration'
import TermsAndConditionsModal from 'src/components/terms-and-conditions/TermsAndConditionsModal'
import FastLoadingScreen from 'src/components/FastLoadingScreen'
import 'src/router'

const components = {
  TermsAndConditionsModal,
  FastLoadingScreen
}

if (process.env.DEV) {
  const DevButton = defineAsyncComponent(() => import('src/components/tests/DevButton'))
  components.DevButton = DevButton
}

export default {
  name: 'App',
  mixins: [
    PlatformMixin,
    LanguageMixin
  ],
  components,
  data () {
    return {
      showDevButton: process.env.DEV,
      initialized: false
    }
  },
  computed: {
    isTermsAndConditionsReady () {
      return this.initialized && this.isConfigValid
    },
    isConfigValid () {
      return !this.$store.getters['fastplatform/isConfigInvalid']
    }
  },
  async mounted () {
    console.time('App initialization')

    // Global instance used in Leaflet popups for router access // TODO find a cleaner solution
    window.__fast_app = this

    // Init error handler
    initErrorHandler(this.$router)

    // Set preferred language
    try {
      const preferredLanguage = this.$store.state.fastplatform.preferredLanguage ?? 'en'
      await this.setPlatformLanguage(preferredLanguage)
    } catch (e) {
      this.$language.current = 'en'
      console.error('Could not set language', e)
    }

    // Update and initialize the region config and services if region and user are defined
    try {
      //! regionConfigService must be imported dynamically because it depends on Oauthh2Client plugin which is initialized after App.vue
      const { loadTopLevelConfig, refreshRegionConfig } = await import('src/services/region-config')
      await loadTopLevelConfig()
      await refreshRegionConfig(this.isMobileApp)
    } catch (e) {
      console.warn('App config init failed', e)
      if (!this.isConfigValid) {
        onInvalidConfigError()
      }
    }

    // Initialize services if config is valid (if not, user will be redirected to the login page)
    if (this.isConfigValid) {
      // Init mobile services
      if (this.isMobileApp) {
      // Init push notifications and upload services
        initMobileServices(this.isIos)

        // listen for deep links event and open the correct page in case of an incoming event
        listenDeepLinks(this.$router)

        // Handle app state changes
        await App.addListener('appStateChange', state => {
          if (state.isActive) {
            // actions reserved to the mobile app
            if (uploadServiceInstance) {
              // start the upload job
              uploadServiceInstance.startUpload()
            }
          }
        })
      } else {
      // Init upload service for web
        initializeUploadService(this.isIos)
      }

      // Initialize the error logger
      await initSentry()

      // Refresh surface unit configuration if the user is logged in (no need to wait for completion)
      loadPortalConfiguration()
    }

    this.initialized = true

    // hide splash screen
    await SplashScreen.hide()

    console.timeEnd('App initialization')
  }
}
</script>
